summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJannis Pohlmann <jannis.pohlmann@codethink.co.uk>2012-03-23 18:20:20 +0000
committerJannis Pohlmann <jannis.pohlmann@codethink.co.uk>2012-03-23 18:20:20 +0000
commit7dd7c3015342cc0239ea5869bfaab8df5a2e83c3 (patch)
tree363ee9098945637caf5a1013a46ee0615292aef7
parentd39fb28439d1c1d0352865bb5b9dae17341c5a22 (diff)
downloadtbdiff-7dd7c3015342cc0239ea5869bfaab8df5a2e83c3.tar.gz
Add a new tbdiff-switch command to switch a system to a new subvolume.
-rw-r--r--Makefile.am1
-rw-r--r--configure.ac1
-rw-r--r--tbdiff-switch/Makefile.am20
-rwxr-xr-xtbdiff-switch/tbdiff-switch80
4 files changed, 102 insertions, 0 deletions
diff --git a/Makefile.am b/Makefile.am
index e26010b..d3fc717 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -19,6 +19,7 @@ SUBDIRS = \
tbdiff \
tbdiff-create \
tbdiff-deploy \
+ tbdiff-switch \
tbdiff-update \
tests
diff --git a/configure.ac b/configure.ac
index 320cf86..6ee08fe 100644
--- a/configure.ac
+++ b/configure.ac
@@ -119,6 +119,7 @@ tbdiff/Makefile
tbdiff/tbdiff-1.pc
tbdiff-create/Makefile
tbdiff-deploy/Makefile
+tbdiff-switch/Makefile
tbdiff-update/Makefile
tests/Makefile
])
diff --git a/tbdiff-switch/Makefile.am b/tbdiff-switch/Makefile.am
new file mode 100644
index 0000000..596172e
--- /dev/null
+++ b/tbdiff-switch/Makefile.am
@@ -0,0 +1,20 @@
+# vi:set ts=8 sw=8 noet ai nocindent:
+# -
+# Copyright (c) 2011-2012 Codethink Ltd.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License Version 2 as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+# vi:set ts=8 sw=8 noet ai nocindent:
+
+bin_SCRIPTS = \
+ tbdiff-switch
diff --git a/tbdiff-switch/tbdiff-switch b/tbdiff-switch/tbdiff-switch
new file mode 100755
index 0000000..c2b168d
--- /dev/null
+++ b/tbdiff-switch/tbdiff-switch
@@ -0,0 +1,80 @@
+#!/bin/sh
+#
+# Copyright (c) 2011-2012 Codethink Ltd.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License Version 2 as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+# vi:set ts=8 sw=8 noet ai nocindent:
+
+set -e
+set -x
+
+# read input parameters
+device="$1"
+target_subvolume="$3"
+
+# print usage information if not all parameters are provided
+if [ -z "$device" ] ||
+ [ -z "$target_subvolume" ]
+then
+ echo "Usage: $0 <device> <target subvolume>" >&2
+ exit 1
+fi
+
+if [ ! -f "$patch_file" ]; then
+ echo "Patch file \"$patch_file\" does not exist" >&2
+ exit 1
+fi
+
+# mount the root btrfs file system
+rootfs="$(busybox mktemp -d)"
+mount -t btrfs "$device" "$rootfs"
+trap "cd /; umount $rootfs; busybox rm -rf $rootfs" EXIT SIGINT SIGTERM
+
+# switch into the root file system
+cd "$rootfs"
+
+# verify that the target subvolume exists
+if [ ! -e "$target_subvolume" ]; then
+ echo "Target subvolume \"$target_subvolume\" does not yet exist" >&2
+ exit 1
+fi
+
+# delete the target subvolume's -run snapshot if it exists
+if [ -e "$target_subvolume-run" ]; then
+ echo "Deleting existing snapshot \"$target_subvolume-run\""
+ btrfs subvolume delete "$target_subvolume-run"
+ exit 1
+fi
+
+echo "Creating snapshot \"$target_subvolume-run\" from \"$target_subvolume\""
+
+# create a a new -run snapshot for the target subvolume
+btrfs subvolume snapshot "$target_subvolume" "$target_subvolume-run"
+
+echo "Copying boot files to the root file system"
+
+# copy boot files to the root file system
+busybox cp "$target_subvolume/boot/vmlinuz" "boot/vmlinuz"
+busybox cp "$target_subvolume/boot/System.map" "boot/System.map"
+busybox cp "$target_subvolume/extlinux.conf" "extlinux.conf"
+
+echo "Configuring extlinux to boot from \"$target_subvolume-run\""
+
+busybox sed -i -e "s,factory-run,$target_subvolume-run,g" "extlinux.conf"
+
+# leave the root file system
+cd /
+
+# reboot the system
+busybox reboot